Codeforces Round #200 (Div. 2) (ABCDE题解)

54 篇文章 0 订阅
53 篇文章 0 订阅

比赛链接:http://codeforces.com/contest/344


A. Magnets
time limit per test:1 second
memory limit per test:256 megabytes

Mad scientist Mike entertains himself by arranging rows of dominoes. He doesn't need dominoes, though: he uses rectangular magnets instead. Each magnet has two poles, positive (a "plus") and negative (a "minus"). If two magnets are put together at a close distance, then the like poles will repel each other and the opposite poles will attract each other.

Mike starts by laying one magnet horizontally on the table. During each following step Mike adds one more magnet horizontally to the right end of the row. Depending on how Mike puts the magnet on the table, it is either attracted to the previous one (forming a group of multiple magnets linked together) or repelled by it (then Mike lays this magnet at some distance to the right from the previous one). We assume that a sole magnet not linked to others forms a group of its own.

Mike arranged multiple magnets in a row. Determine the number of groups that the magnets formed.

Input

The first line of the input contains an integer n (1 ≤ n ≤ 100000) — the number of magnets. Then n lines follow. The i-th line (1 ≤ i ≤ n) contains either characters "01", if Mike put the i-th magnet in the "plus-minus" position, or characters "10", if Mike put the magnet in the "minus-plus" position.

Output

On the single line of the output print the number of groups of magnets.

Sample test(s)
Input
6
10
10
10
01
10
10
Output
3
Input
4
01
01
10
10
Output
2
Note

The first testcase corresponds to the figure. The testcase has three groups consisting of three, one and two magnets.

The second testcase has two groups, each consisting of two magnets.


题目大意:其实就是求连续的01和10组数的和


题目分析:小模拟


#include <cstdio>
int const MAX = 1e5 + 5;
int a[MAX];

int main()
{
    int n, ans = 0;
    scanf("%d", &n);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d", &a[i]);
        ans += (a[i] == a[i - 1] ? 0 : 1);
    }
    printf("%d\n", ans);
}



B. Simple Molecules
time limit per test:1 second
memory limit per test:256 megabytes

Mad scientist Mike is busy carrying out experiments in chemistry. Today he will attempt to join three atoms into one molecule.

A molecule consists of atoms, with some pairs of atoms connected by atomic bonds. Each atom has a valence number — the number of bonds the atom must form with other atoms. An atom can form one or multiple bonds with any other atom, but it cannot form a bond with itself. The number of bonds of an atom in the molecule must be equal to its valence number.

Mike knows valence numbers of the three atoms. Find a molecule that can be built from these atoms according to the stated rules, or determine that it is impossible.

Input

The single line of the input contains three space-separated integers a, b and c (1 ≤ a, b, c ≤ 106) — the valence numbers of the given atoms.

Output

If such a molecule can be built, print three space-separated integers — the number of bonds between the 1-st and the 2-nd, the 2-nd and the 3-rd, the 3-rd and the 1-st atoms, correspondingly. If there are multiple solutions, output any of them. If there is no solution, print "Impossible" (without the quotes).

Sample test(s)
Input
1 1 2
Output
0 1 1
Input
3 4 5
Output
1 3 2
Input
4 1 1
Output
Impossible
Note

The first sample corresponds to the first figure. There are no bonds between atoms 1 and 2 in this case.

The second sample corresponds to the second figure. There is one or more bonds between each pair of atoms.

The third sample corresponds to the third figure. There is no solution, because an atom cannot form bonds with itself.

The configuration in the fourth figure is impossible as each atom must have at least one atomic bond.


题目大意:三个点,给出每个点的度,要求不能有自环,且三点连通,问1-2,2-3,3-1之间各有几条边


题目分析:首先一条边会对总度数增加2,所以a + b+ c必是偶数,设答案是x,y,z,则有

a = x + z

b = x + y

c = y + z

解得

x = (a + b - c) / 2

y = (b + c - a) / 2

z = (a + c - b) / 2

又x,y,z大于等于0且是整数得到:

x = (a + b - c) / 2

y = b - x

z = a - x


#include <cstdio>

int main()
{
    int a, b, c;
    scanf("%d %d %d", &a, &b, &c);
    if((a + b + c) & 1)
    {
        printf("Impossible\n");
        return 0;
    }
    int t1 = a + b - c;
    int t2 = b + c - a;
    int t3 = a + c - b;
    if((t1 != 0 && t1 % 2) || t1 < 0)
    {
        printf("Impossible\n");
        return 0;
    }
    if((t2 != 0 && t2 % 2) || t2 < 0)
    {
        printf("Impossible\n");
        return 0;
    }
    if((t3 != 0 && t3 % 2) || t3 < 0)
    {
        printf("Impossible\n");
        return 0;
    }
    printf("%d %d %d\n", t1 / 2, b - t1 / 2, a - t1 / 2);
}



C. Rational Resistance
time limit per test:1 second
memory limit per test:256 megabytes

Mad scientist Mike is building a time machine in his spare time. To finish the work, he needs a resistor with a certain resistance value.

However, all Mike has is lots of identical resistors with unit resistance R0 = 1. Elements with other resistance can be constructed from these resistors. In this problem, we will consider the following as elements:

  1. one resistor;
  2. an element and one resistor plugged in sequence;
  3. an element and one resistor plugged in parallel.

With the consecutive connection the resistance of the new element equals R = Re + R0. With the parallel connection the resistance of the new element equals . In this case Re equals the resistance of the element being connected.

Mike needs to assemble an element with a resistance equal to the fraction . Determine the smallest possible number of resistors he needs to make such an element.

Input

The single input line contains two space-separated integers a and b (1 ≤ a, b ≤ 1018). It is guaranteed that the fraction is irreducible. It is guaranteed that a solution always exists.

Output

Print a single number — the answer to the problem.

Please do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cin, cout streams or the %I64d specifier.

Sample test(s)
Input
1 1
Output
1
Input
3 2
Output
3
Input
199 200
Output
200
Note

In the first sample, one resistor is enough.

In the second sample one can connect the resistors in parallel, take the resulting element and connect it to a third resistor consecutively. Then, we get an element with resistance . We cannot make this element using two resistors.

题目大意:每个小电阻为1,现在要得到a/b的电阻,可串连可并连,问最少要用几个小电阻


题目分析:考虑a/b,如果并联一个1则变成(a + b) / b,如果串连一个1则变成b / (a + b),可见一个数如果大于1则不断减,减到小于1,相当于直接除,然后再取倒数一直到分子为0


#include <cstdio>
#include <algorithm>
#define ll long long
using namespace std;

int main()
{
    ll a, b, ans = 0;
    scanf("%I64d %I64d", &a, &b);
    if(a >= b)
        ans += a / b;
    a = a % b;
    while(a)
    {
        swap(a, b);
        ans += a / b;
        a = a % b;
    }
    printf("%I64d\n", ans);
}



D. Alternating Current
time limit per test:1 second
memory limit per test:256 megabytes

Mad scientist Mike has just finished constructing a new device to search for extraterrestrial intelligence! He was in such a hurry to launch it for the first time that he plugged in the power wires without giving it a proper glance and started experimenting right away. After a while Mike observed that the wires ended up entangled and now have to be untangled again.

The device is powered by two wires "plus" and "minus". The wires run along the floor from the wall (on the left) to the device (on the right). Both the wall and the device have two contacts in them on the same level, into which the wires are plugged in some order. The wires are considered entangled if there are one or more places where one wire runs above the other one. For example, the picture below has four such places (top view):

Mike knows the sequence in which the wires run above each other. Mike also noticed that on the left side, the "plus" wire is always plugged into the top contact (as seen on the picture). He would like to untangle the wires without unplugging them and without moving the device. Determine if it is possible to do that. A wire can be freely moved and stretched on the floor, but cannot be cut.

To understand the problem better please read the notes to the test samples.

Input

The single line of the input contains a sequence of characters "+" and "-" of length n (1 ≤ n ≤ 100000). The i-th (1 ≤ i ≤ n) position of the sequence contains the character "+", if on the i-th step from the wall the "plus" wire runs above the "minus" wire, and the character "-" otherwise.

Output

Print either "Yes" (without the quotes) if the wires can be untangled or "No" (without the quotes) if the wires cannot be untangled.

Sample test(s)
Input
-++-
Output
Yes
Input
+-
Output
No
Input
++
Output
Yes
Input
-
Output
No
Note

The first testcase corresponds to the picture in the statement. To untangle the wires, one can first move the "plus" wire lower, thus eliminating the two crosses in the middle, and then draw it under the "minus" wire, eliminating also the remaining two crosses.

In the second testcase the "plus" wire makes one full revolution around the "minus" wire. Thus the wires cannot be untangled:

In the third testcase the "plus" wire simply runs above the "minus" wire twice in sequence. The wires can be untangled by lifting "plus" and moving it higher:

In the fourth testcase the "minus" wire runs above the "plus" wire once. The wires cannot be untangled without moving the device itself:



题目大意:题目很难读,给一串+-,如果当前的+或者-和前一个一样则消去,问最后能不能全部消去

题目分析:栈模拟



#include <cstdio>
#include <cstring>
#include <stack>
using namespace std;
int const MAX = 1e5 + 5;
char s[MAX];
stack <char> st;

int main()
{
    scanf("%s", s);
    int len = strlen(s);
    st.push('#');
    for(int i = 0; i < len; i++)
    {
        if(s[i] == st.top())
            st.pop();
        else
            st.push(s[i]);
    }
    if((int)st.size() == 1)
        printf("Yes\n");
    else
        printf("No\n");
}




E. Read Time
time limit per test:1 second
memory limit per test:256 megabytes

Mad scientist Mike does not use slow hard disks. His modification of a hard drive has not one, but n different heads that can read data in parallel.

When viewed from the side, Mike's hard drive is an endless array of tracks. The tracks of the array are numbered from left to right with integers, starting with 1. In the initial state the i-th reading head is above the track number hi. For each of the reading heads, the hard drive's firmware can move the head exactly one track to the right or to the left, or leave it on the current track. During the operation each head's movement does not affect the movement of the other heads: the heads can change their relative order; there can be multiple reading heads above any of the tracks. A track is considered read if at least one head has visited this track. In particular, all of the tracks numbered h1, h2, ..., hn have been read at the beginning of the operation.

Mike needs to read the data on m distinct tracks with numbers p1, p2, ..., pm. Determine the minimum time the hard drive firmware needs to move the heads and read all the given tracks. Note that an arbitrary number of other tracks can also be read.

Input

The first line of the input contains two space-separated integers n, m (1 ≤ n, m ≤ 105) — the number of disk heads and the number of tracks to read, accordingly. The second line contains n distinct integers hi in ascending order (1 ≤ hi ≤ 1010, hi < hi + 1) — the initial positions of the heads. The third line contains m distinct integers pi in ascending order (1 ≤ pi ≤ 1010, pi < pi + 1) - the numbers of tracks to read.

Please, do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cin, cout streams or the %I64d specifier.

Output

Print a single number — the minimum time required, in seconds, to read all the needed tracks.

Sample test(s)
Input
3 4
2 5 6
1 3 6 8
Output
2
Input
3 3
1 2 3
1 2 3
Output
0
Input
1 2
165
142 200
Output
81
Note

The first test coincides with the figure. In this case the given tracks can be read in 2 seconds in the following way:

  1. during the first second move the 1-st head to the left and let it stay there;
  2. move the second head to the left twice;
  3. move the third head to the right twice (note that the 6-th track has already been read at the beginning).

One cannot read the tracks in 1 second as the 3-rd head is at distance 2 from the 8-th track.


题目大意:n个磁头,m个目标位置,每一次操作每个磁头都可以往左或往右走一格,现在问最少要操作几次可以访问到所有的目标位置

题目分析:典型的二分题,二分这个时间,开始上界弄小wa了,来回一趟最多1e11即可,每次判断最左边的磁头记h0和最左边的目标位置记为p0,如果h0小于p0则直接往右走到最远,否则要判断它先向左再向右移的远还是先向右再向左移的远,取最大为当前最远位置,经过的目标点做标记,一旦最后一个标记点被标记则表示当前二分的时间点满足条件,继续搜索取最小时间

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
int const MAX = 1e5 + 5;
ll const INF = 1e11 + 5;
ll h[MAX], p[MAX];
bool vis[MAX];
int n, m;

bool ok(ll x)
{
    memset(vis, false, sizeof(vis));
    int cur = 0;
    ll dis = 0;
    for(int i = 0; i < n; i++)
    {
        if(h[i] <= p[cur])
            dis = h[i] + x;
        else
        {
            if(x < (h[i] - p[cur]))
                return false;
            dis = max(p[cur] + x - (h[i] - p[cur]), h[i] + (x - (h[i] - p[cur])) / 2);
        }
        int idx;
        for(int j = cur; j < m; j++)
        {
            if(p[j] <= dis)
                vis[j] = true;
            else
            {
                idx = j;
                break;
            }
        }
        if(vis[m - 1])
            return true; 
        cur = idx;
    }
    return false;
}

int main()
{
    scanf("%d %d", &n, &m);
    for(int i = 0; i < n; i++)
        scanf("%I64d", &h[i]);
    for(int i = 0; i < m; i++)
        scanf("%I64d", &p[i]);
    ll l = 0, r = INF, mid, ans;
    while(l <= r)
    {
        mid = (l + r) >> 1;
        if(ok(mid))
        {
            ans = mid;
            r = mid - 1;
        }
        else
            l = mid + 1;
    }
    printf("%I64d\n", ans);
}




评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值